; *********************************************************************
; 			Special effect : Water Effect
; *********************************************************************

	NEW_SPRITE
	ADD_CAR R_cpt,2		; Compteur de l''etat de la respration
	ADD_CAR Water_fg,2	; Sous l'eau ?
	TAILLE_SPRITE	Taille_special4
	
special4_init:
	clr.b	Water_fg(a5)
	move.w	#OXYGENE_TMP,R_cpt(a5)
	rts

special4_exe:
	; Calcul hauteur du perso
	move.l	Sprite_adr(a6),a3
	move.w	Y(a3),d3
	sub.w	#16,d3

	tst.b	Water_fg(a5)
	beq.s	\No_water
		subq.w	#1,R_cpt(a5)	; On respire moins
		beq.s	\Water_dead
		; Calcul des bulles...
		moveq	#0,d2
		move.w	R_cpt(a5),d2
		lsr.w	#4,d2
			move.l	d3,d0
			moveq	#40,d3	; X
			moveq	#0,d4	; Y
			moveq	#2,d1	; 1 chiffre
			bsr	put_number
			move.l	d0,d3
		move.l	d7,d1
		swap	d1
		addq.w	#2,d2
		and.w	d2,d1
		bne.s	\no_init
			move.w	X(a3),d0
			move.w	d3,d1
			moveq	#SPR_BULLE,d2
			bsr	Init_sprite
\no_init:
		cmp.w	Water_level(a6),d3
		bhi.s	\End_test_water
			clr.b	All_window(a6)
			clr.b	Water_fg(a5)		; On sort de l'eau
			lea	Inc_Vitesse-8(Pc),a0	; On remet la table normale
			lea	Inc_Vitesse_normal(Pc),a1
			move.l	(a1)+,(a0)+
			move.l	(a1),(a0)+
			move.l	(a1),(a0)+
			move.l	-(a1),(a0)+
			bra.s	\Eclat
\Water_dead:
		move.w	#_INIT_DEAD,Action(a3)
		bra.s	\End_test_water
\No_water:
		cmp.w	Water_level(a6),d3
		bls.s	\End_test_water
			st.b	All_window(a6)
			st.b	Water_fg(a5)	; On rentre dans l'eau
			move.w	#OXYGENE_TMP,R_cpt(a5)
			lea	Inc_Vitesse-8(Pc),a0	; On remet la table normale
			lea	Inc_water_table(Pc),a1
			move.l	(a1)+,(a0)+
			move.l	(a1),(a0)+
			move.l	(a1),(a0)+
			move.l	-(a1),(a0)+
\Eclat:
			moveq	#SPR_ECLAT,d2
			move.w	X(a3),d0
			move.w	Water_level(a6),d1
			sub.w	#30,d1
			moveq	#5,d4
			bsr	Init_sprite
\End_test_water:

	rts

Inc_water_table:
	dc.l	0
	dc.l	65536/16/TURBO/MOVING
Inc_Vitesse_normal:
	dc.l	65536/4/TURBO/MOVING
	dc.l	65536/2/TURBO/MOVING

special4_putexe:
	move.l	(a7)+,d0	; Pop the return adress
	pea	special4_draw(Pc)
	move.l	d0,-(a7)
	rts
special4_draw:
	moveq	#(SCREEN_Y-1),d0	; D0 = nbr de ligne
	move.l	Plan_A_adr(a6),a0	;
	move.l	Current_dscreen(a6),a1	; A1 = Ecran
	move.w	Water_level(a6),d1	; Niveau de l'eau
	sub.w	PLANE_YS(a0),d1
	ble.s	\Start

	move.w	d1,d0
	cmpi.w	#SCREEN_Y,d0
	bcc.s	\NoPrint

	add.w	d1,d1
	move.w	d1,d2
	lsl.w	#4,d1
	sub.w	d2,d1	; D1 x 30

	add.w	d1,a1

	neg.w	d0
	addi.w	#(SCREEN_Y-1),d0
\Start:
	move.l	#$CCCCCCCC,d3		; Masque
	lea	SCREEN_SIZE(a1),a0
\Loop1:
		move.l	d3,d4
		not.l	d4
		moveq	#28/4-1,d1
\Loop2:		
			and.l	d3,(a1)+
			or.l	d4,(a0)+
			dbf	d1,\Loop2
		and.w	d3,(a1)+
		or.w	d4,(a0)+
		rol.l	#2,d3
	dbf.s	d0,\Loop1
\NoPrint:
	rts
