; Detection de Hardware v2.00 ?
; Recherche de presence de libraries non valides dans le programme !
	EVEN
Anti_crash_protection:
	move.w	#((prog_end-prog_start)/2),d0
	lea	prog_start,a0
\loop:	move.w	(a0)+,d1
	cmp.w	#$4EB9,d1		; jsr ?
	bne.s	\ok
	tst.w	(a0)			; 0000
	bne.s	\ok
	tst.w	2(a0)			; 0000 ?
	beq.s	\library_error		; Jsr $0 => Library error !
\ok:	dbf.s	d0,\loop
	rts
\library_error:				; Since there is a error on library, we can't use them !
	pea	library_str(Pc)
	ROM_CALL romfunc::ST_showHelp	; Show the string
	addq.l	#4,a7			; Restore the stack pointer
	; Wait for a key
	lea	$600000,a0		; Set a0 to I/O for direct prot access
	clr.l	($18)(a0)		; Mask to read keys
\Wait:	move.b	$1B(a0),d0		; Wait for all keys
	cmpi.b	#$FF,d0
	bne.s	\Wait
\Loop	move.b	$1B(a0),d0		; Wait for all keys
	cmpi.b	#$FF,d0
	beq.s	\Loop
\hard2:	addq.l	#4,a7			; Quit the program
	rts

library_str:
	dc.b "Libraries relocation error",0
	EVEN

; Permets (?) de determiner l'origine d'un crash.

; Use :
;	move.w	#data,-(sp)
;	bsr	memorise_data_from_crash
;	addq.l	#2,sp

;	ifne	DEBUG
;memorise_data_from_crash:;
;	movem.l	d0/a0,-(sp)
;	lea	numero(Pc),a0
;	move.w	(a0),d0
;	move.w	(4+4+4+2)(a7),2(a0,d0.w)
;	addq.w	#2,d0
;	cmp.w	#2000,d0
;	bls.s	\ok
;		clr.w	d0
;\ok:	move.w	d0,(a0)
;	movem.l	(a7)+,d0/a0
;	rts
;
;_exit:
;	bra.s	_exit
;	rts

;numero:	dc.w	0
;table	ds.w	1001
;	endif
