; *********************************************************************
; 			Panneau qui tourne
;	(D'accord, la description du sprite est nulle :))
; *********************************************************************

	NEW_SPRITE
	ADD_CAR	Act,2
	ADD_CAR	Cpt,2
	SIZE_SPRITE	Size_panneau

PAN_ACT_DEBUT		EQU	0
PAN_ACT_MONTE		EQU	2
PAN_ACT_DESCENTE	EQU	4
PAN_ACT_FIN		EQU	6

PAN_CPT			EQU	5*16/4

panneau_init:
	clr.w	Act(a5)
	rts

panneau_exe:
	move.w	Xj(a5),d0
	move.w	Yj(a5),d1
	add.w	#16,d0
	add.w	#20,d1

	move.l	Plan_A_adr(a6),a0
	move.w	PLANE_XS(a0),d2

	; Rapproche le scrolling
	clr.w	Scroll_ax(a6)
	swap	d6
	cmp.w	d6,d0
	bhi.s	\else
	move.w	d2,xmax(a6)
	bra.s	\done
\else:	move.w	d2,xmin(a6)
\done:	swap	d6

	; Main action
	move.w	Act(a5),d2
	move.w	panneau_table(Pc,d2.w),d2
	jmp	panneau_table(Pc,d2.w)

panneau_table:
	dc.w	panneau_debut-panneau_table
	dc.w	panneau_monte-panneau_table
	dc.w	panneau_descente-panneau_table
	dc.w	panneau_fin-panneau_table

panneau_debut:
	test_sonic_collision2.s d0,d1,32,40,d2,d3,panneau_no_collision
	move.w	#PAN_ACT_MONTE,Act(a5)
	move.w	#PAN_CPT,Cpt(a5)
	move.w	#ANI_PANNEAU2,Ani(a5)
panneau_no_collision:
	rts

panneau_monte:
	subq.w	#1,Cpt(a5)
	bne.s	\do
	move.w	#PAN_ACT_DESCENTE,Act(a5)
	move.w	#PAN_CPT,Cpt(a5)
\do:	subq.w	#4,Yj(a5)
	subq.w	#(3*2),Scroll_ay(a6)
	rts

panneau_descente:
	subq.w	#1,Cpt(a5)
	bne.s	\do
	move.w	#PAN_ACT_FIN,Act(a5)
	move.w	#ANI_PANNEAU3,Ani(a5)
	bsr	obj_panneau
\do:	addq.w	#4,Yj(a5)
	rts

panneau_fin:
	rts

