; *********************************************************************
; 				Special effect
; *********************************************************************

	NEW_SPRITE
	ADD_CAR	Dhz_table,SCREEN_Y
	ADD_CAR	Hdz_table,2*SCREEN_Y
	TAILLE_SPRITE	Taille_special1
	
special1_init:
	; Generate the dhz buffer
	lea	Dhz_table(a5),a0
	move.l	a0,Dhz_A_table(a6)
	moveq	#(-3),d0
	bsr.s	special1_copy_16		; 16
	addq.b	#1,d0
	bsr.s	special1_copy_16		; 32
	addq.b	#1,d0
	bsr.s	special1_copy_16		; 48
	addq.b	#1,d0
	bsr.s	special1_copy_16		; 64
	subq.b	#1,d0
	bsr.s	special1_copy_16		; 80
	subq.b	#1,d0
	bsr.s	special1_copy_16		; 96
	subq.b	#1,d0
	bsr.s	special1_copy_16		; 112
	subq.b	#1,d0
	bsr.s	special1_copy_16		; 128

	; Generate the Hdz buffer)
	lea	Hdz_table(a5),a0
	move.l	a0,Hdz_A_table(a6)
	moveq	#(SCREEN_Y/32-1),d0
\loop:	move.w	#-VIRTUAL_X,(a0)+
	moveq	#(15-1),d1
\lp:	clr.w	(a0)+
	dbf.s	d1,\lp
	move.w	#VIRTUAL_X,(a0)+
	moveq	#(15-1),d1
\lp2:	clr.w	(a0)+
	dbf.s	d1,\lp2
	dbf.s	d0,\loop

	rts

special1_copy_16:
	moveq	#15,d1
\lopp:	move.b	d0,(a0)+
	dbf	d1,\lopp
	rts
	
special1_exe:
	; Update the dhz table : rotation
	lea	Dhz_table(a5),a0
	lea	1(a0),a1
	move.b	(a0),d3
	moveq	#(SCREEN_Y-2),d1
\loop2:	move.b	(a1)+,(a0)+
	dbf	d1,\loop2
	move.b	d3,(a0)

	; Update the Hdz table
	lea	Hdz_table(a5),a0
	lea	2(a0),a1
	move.w	(a0),d3
	moveq	#(SCREEN_Y-2),d1
\loop3:	move.w	(a1)+,(a0)+
	dbf	d1,\loop3
	move.w	d3,(a0)

	rts
